#ifndef __LCD_H
#define __LCD_H		
#include "sys.h"	 
#include "stdlib.h"

//SPIʾӿ
//LCD_RST
#define SPILCD_RST_SET  GPIO_SetBits(GPIOB, GPIO_Pin_0)//PB0 
#define SPILCD_RST_RESET GPIO_ResetBits(GPIOB, GPIO_Pin_0)//PB0  
//LCD_RS//dc  
#define SPILCD_RS_SET  GPIO_SetBits(GPIOC, GPIO_Pin_4)//PC4 
#define SPILCD_RS_RESET  GPIO_ResetBits(GPIOC, GPIO_Pin_4)//PC4  
//LCD_CS  
#define SPILCD_CS_SET GPIO_SetBits(GPIOA, GPIO_Pin_4)//PA4 
#define SPILCD_CS_RESET  GPIO_ResetBits(GPIOA, GPIO_Pin_4)//PA4 

  
//LCDҪ
typedef struct  
{ 					    
	u16 width;			//LCD 
	u16 height;			//LCD ߶
	u16 id;				//LCD ID
	u8	wramcmd;		//ʼдgramָ
	u8  setxcmd;		//xָ
	u8  setycmd;		//yָ	 
}_lcd_dev; 	  

//LCD
extern _lcd_dev lcddev;	//LCDҪ
//LCDĻɫͱɫ	   
extern u16  POINT_COLOR;//ĬϺɫ    
extern u16  BACK_COLOR; //ɫ.ĬΪɫ


//////////////////////////////////////////////////////////////////////////////////	 
//-----------------LCD˿ڶ---------------- 
#define	LCD_REST PBout(1) //LCD REST    		 PB1 	    
//LCDַṹ
typedef struct
{
	u16 LCD_REG;
	u16 LCD_RAM;
} LCD_TypeDef;
//ʹNOR/SRAM Bank1.sector4,ַλHADDR[27,26]=11 A10Ϊ 
//עʱSTM32ڲһλ! 111110=0X3E			    
#define LCD_BASE        ((u32)(0x60000000 | 0x0007FFFE))
#define LCD             ((LCD_TypeDef *) LCD_BASE)
//////////////////////////////////////////////////////////////////////////////////

//ɫ
#define WHITE         	 0xFFFF
#define BLACK         	 0x0000	  
#define BLUE         	 0x001F  
#define BRED             0XF81F
#define GRED 			 0XFFE0
#define GBLUE			 0X07FF
#define RED           	 0xF800
#define MAGENTA       	 0xF81F
#define GREEN         	 0x07E0
#define CYAN          	 0x7FFF
#define YELLOW        	 0xFFE0
#define BROWN 			 0XBC40 //ɫ
#define BRRED 			 0XFC07 //غɫ
#define GRAY  			 0X8430 //ɫ
//GUIɫ

#define DARKBLUE      	 0X01CF	//ɫ
#define LIGHTBLUE      	 0X7D7C	//ǳɫ  
#define GRAYBLUE       	 0X5458 //ɫ
//ɫΪPANELɫ 
 
#define LIGHTGREEN     	 0X841F //ǳɫ
//#define LIGHTGRAY        0XEF5B //ǳɫ(PANNEL)
#define LGRAY 			 0XC618 //ǳɫ(PANNEL),屳ɫ

#define LGRAYBLUE        0XA651 //ǳɫ(мɫ)
#define LBBLUE           0X2B12 //ǳɫ(ѡĿķɫ)
	    															  
void LCD_Init(void);													   	//ʼ
void LCD_DisplayOn(void);													//ʾ
void LCD_DisplayOff(void);													//ʾ
void LCD_Clear(u16 Color);	 												//
void LCD_SetCursor(u16 Xpos, u16 Ypos);										//ù
void LCD_DrawPoint(u16 x,u16 y);											//
void LCD_Fast_DrawPoint(u16 x,u16 y,u16 color);								//ٻ
void Draw_Circle(u16 x0,u16 y0,u8 r);										//Բ
void LCD_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2);							//
void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2);		   				//
void LCD_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u16 color);		   				//䵥ɫ
void LCD_Color_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u16 *color);				//ָɫ
void LCD_ShowChar(u16 x,u16 y,u8 num,u8 size,u8 mode);						//ʾһַ
void LCD_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 size);  						//ʾһ
void LCD_ShowxNum(u16 x,u16 y,u32 num,u8 len,u8 size,u8 mode);				//ʾ 
void LCD_ShowString(u16 x,u16 y,u16 width,u16 height,u8 size,u8 *p);		//ʾһַ,12/16
	  
void showimage(u16 x,u16 y); //ʾ40*40ͼƬ
void LCD_WriteReg(u8 LCD_Reg, u16 LCD_RegValue);
void LCD_WriteRAM_Prepare(void);
void LCD_WR_DATA8(u8 da);   //д8λ  
 
void showhanzi16(unsigned int x,unsigned int y,unsigned char index);//16*16
void showhanzi32(unsigned int x,unsigned int y,unsigned char index);//32*32						  		 
#endif  
	 
	 



